%% Beispiel: Variable vom Typ char
variableMitText = 'Das ist ein Text.'

length(variableMitText)

%% Beispiel: strfind
clc
variable = 'Peter hat sechs Kinder und zwei Hunde';
idKinder = strfind(variable,'Kinder')
idLeerzeichen = strfind(variable,' ')
idLeerzeichen = idLeerzeichen(idLeerzeichen<idKinder)

disp(['Anzahl Kinder: ', variable(idLeerzeichen(end-1)+1:idLeerzeichen(end)-1)])

%% Beispiel: strrep
clc
A = 'Fr Datenanalysen empfehle ich Ihnen Excel!'
B = 'Excel';
C = 'MATLAB';
strrep(A,B,C)

%% Beispiel: num2str
num2str(1.23135356,3)

%% Beispiel: sprintf
clc
ergebnis = 1242/234
sprintf('Das Ergebnis ist %0.2f!\n',ergebnis)

%% Beispiel: sprintf mit disp
clc
haeufigkeit = 'tglich';
tier = 'Murmeltier';

text = sprintf('Das Ergebnis ist %0.2f!\n',ergebnis);
text = [text,sprintf('Und %s grt das %s',haeufigkeit,tier)];
disp(text)

%% Erzeugen eines Cell Arrays
clear
clc
mein_Array = {[1 2 3],'Hallo';pi,[5 6;7 8]}
ausgabe_1 = mein_Array(2,2)
ausgabe_2 = mein_Array{2,2}

%% Beispiel fr cellfun
disp('Gre von mein_Array:')
size(mein_Array)
disp('Gre der Inhalte von mein_Array:')
groesse_Inhalt = cellfun(@size,mein_Array,'UniformOutput',false);
groesse_Inhalt{1,1}
groesse_Inhalt{1,2}
groesse_Inhalt{2,1}
groesse_Inhalt{2,2}

%% Beispiel fr Cell Array mit Text
clc
namen = ...
    {'Hans Schmidt';'Peter Mller';'Karl Zobel';'Walter Krumm'};
idLeer = strfind(namen,' ');
vornamen = cellfun(...
    @(x,y)x(1:y-1),namen,idLeer,'uniformoutput',0)
nachnamen = ...
    cellfun(...
    @(x,y)x(y+1:end),namen,idLeer,'uniformoutput',0)

%% Anwendungsbeispiel: Finden eines Namens in einer Namensliste
clc
namen = ...
    {'Hans','Schmidt';'Peter','Mller';'Karl','Zobel';...
    'Walter','Krumm';'Hanna','Schmidt'};

gesucht = input('Vor- oder Nachname: ','s');
idGefunden = strcmp(namen,gesucht);
reihe = max(idGefunden,[],2)==1;
if sum(reihe)>0
    gefiltert = cellfun(@(x)x,namen(reihe,:),...
        'UniformOutput',false);
    vornamen = gefiltert(:,1);
    nachnamen = gefiltert(:,2);
    antwort = cellfun(@(x,y)sprintf(...
        'gefundener Vor- und Nachname: %s %s\n',x,y),...
        vornamen,nachnamen,'UniformOutput',false);
    disp(strjoin(antwort,'\n'))
else
    disp('Kein Eintrag gefunden.')
end


